#################################################################################
#                                                                               #
#                       Copyright (c) 2003 Andreas Heckel                       #
#                                                                               #
#################################################################################

"""PloneLoginHistory Product"""
import os
from DateTime import DateTime
from Globals import SOFTWARE_HOME, INSTANCE_HOME
from Products.CMFCore import CMFCorePermissions



## The following lines are only useful with the Log.py module
## (which is out of scope from this product)

try:
    # Check if we have to be in debug mode
    if os.path.isfile(os.path.abspath(os.path.dirname(__file__)) + '/debug.txt'):
        DEBUG_MODE = 1
    else:
        DEBUG_MODE = 0


    # Set log options correctly
    import Log
    if DEBUG_MODE:
        Log.LOG_LEVEL = Log.LOG_DEBUG
    else:
        Log.LOG_LEVEL = Log.LOG_NOTICE

    from Log import *
    Log = Log
    Log(LOG_NOTICE, "Starting %s at %d debug level" % (os.path.dirname(__file__), LOG_LEVEL, ))

except:
    LOG_DEBUG = None
    LOG_NOTICE = None
    LOG_WARNING = None
    LOG_ERROR = None
    LOG_CRITICAL = None
    def Log(*args, **kw):
        pass
## Setup instalation home directory

LHT_HOME=''
if os.path.isfile('%s/Products/PloneLoginHistory/version.txt' %SOFTWARE_HOME):
    LHT_HOME='%s/Products/PloneLoginHistory' %SOFTWARE_HOME
elif os.path.isfile('%s/Products/PloneLoginHistory/version.txt' %INSTANCE_HOME):
    LHT_HOME='%s/Products/PloneLoginHistory' %INSTANCE_HOME
else:
    raise RuntimeError, 'Could not setup PRODUCT_HOME. Please have a look at your SOFTWARE_HOME and/or INSTANCE_HOME settings.'    


try:
    CLIENT_HOME = os.environ['CLIENT_HOME']
except KeyError:
    CLIENT_HOME = os.path.join(INSTANCE_HOME, 'var')
    
LOGFILE_HOME=CLIENT_HOME+'/login_history.txt'

# Permissions
LHT_view_all_history_Permission = "View login histories of all users"
LHT_view_all_lastlogin_Permission = "View last login of all users"
LHT_view_my_history_Permission = "View my login history"
LHT_view_my_lastlogin_Permission = "View my last login"
	