import OFS
import Acquisition
import string
import cStringIO
from Products.PloneLoginHistory.LogEntry import *
from Products.PloneLoginHistory.global_symbols import *

class LoginHistoryStorage(OFS.SimpleItem.Item,Acquisition.Implicit):
    """ plug in to store login informations to file system file """
    id = "FileSystem"

    storage_arguments=(
	{'name':'LogFile','type':'string','default':LOGFILE_HOME}, 
	)

    def StoreLog(self,parent,login_date,login_success,login_user,login_browser,login_ip):
	"""store to log"""
	log_written=0
	try:
	    target=parent.LogFile
	    f=open(target,'a')
	    f.write(str(login_date)+'\t'+login_user+'\t'+login_success+'\t'+login_browser+'\t'+login_ip+'\t\n')
	    log_written=1
	except:
	    pass
	return log_written

    def getAllLoginHistories(self,parent,offset=0):
	"""get complete log; TODO offset not implemented"""
	limit=parent.ListLimit-1
	lines=[]
	try:
	    target=parent.LogFile
	    f=open(target,'r')
	    lines=f.readlines()
	    f.close()
	except:
	    pass
	    
	res=[]
	for i in range(len(lines)-1,-1,-1):
	    if len(res)<=limit:
		line=lines[i]
		vals=string.split(line,'\t')
		if len(vals)>=5:
		    entry=LogEntry(vals[0],vals[1],vals[2],vals[3],vals[4])
		res.append(entry)
	return res

    def getMyLoginHistory(self,parent,username,offset=0):
	"""get log for user; TODO offset not implemented"""
	limit=parent.ListLimit-1
	lines=[]
	try:
	    target=parent.LogFile
	    f=open(target,'r')
	    lines=f.readlines()
	    f.close()
	except:
	    pass
	    
	res=[]
	for i in range(len(lines)-1,-1,-1):
	    line=lines[i]
	    vals=string.split(line,'\t')
	    if len(vals)>=5:
		if vals[1]==username:
		    if len(res)<=limit:
			entry=LogEntry(vals[0],vals[1],vals[2],vals[3],vals[4])
			res.append(entry)
	return res

    def getLastLogin(self,parent,username):
	"""get log for user"""
	last=None
	lines=[]
	try:
	    target=parent.LogFile
	    f=open(target,'r')
	    lines=f.readlines()
	    f.close()
	except:
	    pass
	    
	res=[]
	for line in lines:
	    vals=string.split(line,'\t')
	    if len(vals)>=5:
		if vals[1]==username:
		    entry=LogEntry(vals[0],vals[1],vals[2],vals[3],vals[4])
		    last=entry
	return last

    def getMyPreviousLogin(self,parent,username):
	"""get previous log for user ; if None user logged in first time"""
	last=None
	prev=None
	lines=[]
	try:
	    target=parent.LogFile
	    f=open(target,'r')
	    lines=f.readlines()
	    f.close()
	except:
	    pass
	    
	res=[]
	for line in lines:
	    vals=string.split(line,'\t')
	    if len(vals)>=5:
		if vals[1]==username:
		    entry=LogEntry(vals[0],vals[1],vals[2],vals[3],vals[4])
		    prev=last
		    last=entry
	return prev

